function varargout = Interface(varargin) 
% INTERFACE M-file for Interface.fig in Pretraitement
%      INTERFACE, by itself, creates a new INTERFACE or raises the existing
%      singleton*.
%
%      H = INTERFACE returns the handle to a new INTERFACE or the handle to
%      the existing singleton*.
%
%      INTERFACE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in INTERFACE.M with the given input arguments.
%
%      INTERFACE('Property','Value',...) creates a new INTERFACE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Interface_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Interface_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Interface

% Last Modified by GUIDE v2.5 21-Feb-2017 15:23:13

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Interface_OpeningFcn, ...
                   'gui_OutputFcn',  @Interface_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Interface is made visible.
function Interface_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Interface (see VARARGIN)

% Choose default command line output for Interface
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Interface wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Interface_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --------------------------------------------------------------------
function Open_Callback(hObject, eventdata, handles)
% hObject    handle to Open (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%Lire une calchistogramme
[filename, pathname] = uigetfile({'*.*','All Files (*.*)'},'Select an image');

if isequal(filename,0)
  msgbox('You not selected an image','Error','error');  
else  
%Rcuperer le nom du fichier

pname=fullfile(pathname, filename);
BW=imread(pname);
handles.pname=pname;
handles.tochanged=BW;
handles.notchanged=BW;
handles.filenamep=filename;
axes(handles.axesorig);
imshow(BW);
end

handles.tochanged=BW;
guidata(hObject,handles);

% --------------------------------------------------------------------
function CalcHistogramme_Callback(hObject, eventdata, handles)
% 
img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
    histo = imhist(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
    histo = imhist(img);
end
  axes(handles.axesres);
  plot(histo);

% --------------------------------------------------------------------
function Edit_Callback(hObject, eventdata, handles)
% hObject    handle to Edit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
 
% --------------------------------------------------------------------
function Undo_Callback(hObject, eventdata, handles)
% Undo
axes(handles.axesorig)
handles.tochanged=handles.notchanged;
guidata(hObject,handles);
imshow(handles.tochanged);

% --------------------------------------------------------------------
function Select_Callback(hObject, eventdata, handles)
%Select
axes(handles.axesorig);
RI=handles.tochanged;
rect=getrect; % selectioner rectangle
ISelect=imcrop(RI,rect); % utiliser la fonction imcrop pour selectionner une partie
Isx=rect(1);
Isy=rect(2);
Iswidth=rect(3);
Isheight=rect(4);
rectangle('Position',[Isx,Isy,Iswidth,Isheight],'EdgeColor','r'); %faire une rectangle pour chaque partie slectionenr
handles.tochanged=ISelect;
guidata(hObject,handles);
%figure('Toolbar','none','Name','Selected calchistogramme','NumberTitle','off'),
imshow(ISelect);


% --------------------------------------------------------------------
function Rotate_Callback(hObject, eventdata, handles)
%Rotate
RI=handles.tochanged;
prompt = {'Enter the rotation degree'};
dlg_title = 'Rotation degree';
num_lines = 1; %Le nombre de lignes dans le dialogue d'entre
answer = inputdlg(prompt,dlg_title,num_lines);
aN=str2double(answer(1)); %conversion le valeur du cell(1) qui est String au double
I = ones(size(RI));
Lr = imrotate(RI, aN);
Ir = imrotate(I, aN);
Lr(Ir==0) = 255; 

handles.tochanged=Lr;
guidata(hObject,handles);
axes(handles.axesres);
imshow(Lr);

% --------------------------------------------------------------------
function Inverse_Callback(hObject, eventdata, handles)
%Inverse
comp=imcomplement(handles.tochanged);
handles.tochanged=comp;
axes(handles.axesorig);
imshow(comp);
guidata(hObject,handles);



% --------------------------------------------------------------------
function Bord_Callback(hObject, eventdata, handles)
% Boundaries
axes(handles.axesorig);
[B,L,N] = bwboundaries(handles.tochanged);
hold on;
for k=2:length(B),
boundary = B{k};
plot(boundary(:,2),boundary(:,1),'r','LineWidth',2);
end

% --------------------------------------------------------------------
function SaveAs_Callback(hObject, eventdata, handles)
% Save As
[filename, pathname] = uiputfile({'*.jpg;*.jpeg;*.jpe;*.jfif', 'JPEG (*.JPG,*.JPEG,*.JPE,*.JFIF)';
      '*.tif;*.tiff', 'TIF (*.TIF,*.TIFF)'; 
     '*.*',  'All Files (*.*)'},'Save as');
sname=fullfile(pathname, filename);
B=handles.tochanged;
dim=ndims(B);
if(dim==2)
imwrite(handles.tochanged,sname,'tif');
else
    imwrite(handles.tochanged,sname,'jpeg','Quality',100);
end

% --------------------------------------------------------------------
function AfficheMatrix_Callback(hObject, eventdata, handles)
% AfficheMatrix

%Creates an empty 15x6 modal uitable in a new figure window.
   f = figure('Position', [100 100 752 550]);
  % test si unz calchistogramme de niveau de gris
  
    dim=ndims(handles.tochanged);
    if(dim==2)
         j=double(handles.tochanged);
    else
     j=double(rgb2gray(handles.tochanged));
    end
   t = uitable('Parent', f, 'Position', [25 25 700 500]);
   set(t, 'Data', j);

% --------------------------------------------------------------------
function Redo_Callback(hObject, eventdata, handles)
handles.notchanged=handles.tochanged;
axes(handles.axesorig);
imshow(handles.notchanged);

% --------------------------------------------------------------------
function File_Callback(hObject, eventdata, handles)
% hObject    handle to File (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Etirement_Callback(hObject, eventdata, handles)
% Etirement de l'calchistogramme : Etirement the contrast of the calchistogramme so that 1% of the data is saturated 
% at low and high intensities, and display it.
img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end
img_imadjust=imadjust(img);
% figure, imshow(img_imadjust);
% title('Imadjust');
axes(handles.axesres);
handles.tochanged=img_imadjust;
guidata(hObject,handles);
imshow(img_imadjust);

% --------------------------------------------------------------------
function RehaussementCouleur_Callback(hObject, eventdata, handles)

[X, map] = imread('shadow.tif');
shadow = ind2rgb(X,map); % convert to truecolor

srgb2lab = makecform('srgb2lab');
lab2srgb = makecform('lab2srgb');

shadow_lab = applycform(shadow, srgb2lab); % convert to L*a*b*

% the values of luminosity can span a range from 0 to 100; scale them
% to [0 1] range (appropriate for MATLAB(R) intensity images of class double)
% before applying the three contrast enhancement techniques
max_luminosity = 100;
L = shadow_lab(:,:,1)/max_luminosity;

% replace the luminosity layer with the processed data and then convert
% the calchistogramme back to the RGB colorspace
shadow_imadjust = shadow_lab;
shadow_imadjust(:,:,1) = imadjust(L)*max_luminosity;
shadow_imadjust = applycform(shadow_imadjust, lab2srgb);

shadow_histeq = shadow_lab;
shadow_histeq(:,:,1) = histeq(L)*max_luminosity;
shadow_histeq = applycform(shadow_histeq, lab2srgb);

shadow_adapthisteq = shadow_lab;
shadow_adapthisteq(:,:,1) = adapthisteq(L)*max_luminosity;
shadow_adapthisteq = applycform(shadow_adapthisteq, lab2srgb);

figure, imshow(shadow);
title('Original');

figure, imshow(shadow_imadjust);
title('Imadjust');
figure, imshow(shadow_histeq);
title('Histeq');

figure, imshow(shadow_adapthisteq);
title('Adapthisteq');


% --------------------------------------------------------------------
function Profil_Callback(hObject, eventdata, handles)
% hObject    handle to Profil (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.axesorig);
img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end
improfile

% --------------------------------------------------------------------
function Seuillage_Callback(hObject, eventdata, handles)
% hObject    handle to Seuillage (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
img=handles.tochanged;
img=im2double(img);
% figure;subplot(1,2,1);imshow(img);
result=(img>0.5).*img;
% subplot(1,2,2);imshow(result);
axes(handles.axesres);
handles.tochanged=result;
guidata(hObject,handles);
imshow(result);



% --------------------------------------------------------------------
function Fourier_Callback(hObject, eventdata, handles)
% hObject    handle to Fourier (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

img=handles.tochanged;
img=im2double(img);
figure;subplot(1,3,1);imshow(img)
title('Original');
fourier=fft2(img);
% subplot(1,3,2);imshow(real(fourier));
% title('Real-Fourier');
axes(handles.axesres);
handles.tochanged=fourier;
guidata(hObject,handles);
imshow(fourier);

subplot(1,3,3);imshow(imag(fourier));
title('Imag-Fourier');
retour=ifft2(fourier);
figure;imshow(real(retour));
title('Real-retour');
fourier(1:200,1:250) = 0;
retour=ifft2(fourier);
figure;imshow(real(retour));
title('Real-Retour2');
imgresult=abs(minus(retour,img));
figure;mesh(imgresult);
title('Rsultat');

% --------------------------------------------------------------------
function EgalHist_Callback(hObject, eventdata, handles)
% hObject    handle to EgalHist (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end
    img=histeq(img);
    axes(handles.axesres);
    handles.tochanged=img;
    guidata(hObject,handles);
    imshow(img);
%     figure; imshow(img);
  
% --------------------------------------------------------------------
function AdjustwithLimits_Callback(hObject, eventdata, handles)
% Rglez le contraste dans l'calchistogramme  l'aide de stretchlim pour dfinir les limites 
% et afficher le rsultat. L'exemple utilise les limites par dfaut [0,01 0,99], 
%saturant le 1% suprieur et le 1% infrieur.

img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end
img = imadjust(img,stretchlim(img),[]);
handles.tochanged=img;
guidata(hObject,handles);
axes(handles.axesres);
imshow(img);




% --------------------------------------------------------------------
function Filtrage_Callback(hObject, eventdata, handles)
% Des fonctions restent  trouver



% --------------------------------------------------------------------
function Rescale_Callback(hObject, eventdata, handles)
% hObject    handle to Rescale (see GCBO)

img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end
n = 256;
f=img;
f = rescale(sum(f,3));
handles.tochanged=f;
guidata(hObject,handles);
axes(handles.axesres);
imshow(f);



% --------------------------------------------------------------------
function FiltreLineaire_Callback(hObject, eventdata, handles)

% hObject    handle to FiltreLineaire (see GCBO)

axes(handles.axesorig);
img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end

img=double(img)/255.0;
h=-ones(3,3); %Definition de h
h(2,2)=8;
img=filter2(h,img);
%visualization des resultats
% figure(2 );subplot(1,2,1);imshow(I);title('imagetexture originale');

axes(handles.axesres);
handles.tochanged=img;
guidata(hObject,handles);
imshow(img);

%subplot(1,2,2);imshow(img);title('image filtre');
% --------------------------------------------------------------------
function ParEchantFrequence_Callback(hObject, eventdata, handles)
% hObject    handle to ParEchantFrequence (see GCBO)

img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end
I=img;
I1=fft2(I);
h= zeros(9,9);
h(4:6,4:6)=ones(3,3);
H1=fsamp2(h);
G = filter2(H1,I);
G1=ifft2(G);
% figure(1);subplot(1,2,1);imshow(G1);title('frequentiel');
% subplot(1,2,2);imshow (G);title('impulsionnel');
axes(handles.axesres);
handles.tochanged=G1;
guidata(hObject,handles);
imshow(G1);


% --------------------------------------------------------------------
function FiltreMedian_Callback(hObject, eventdata, handles)
% hObject    handle to FiltreMedian (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end
i=img;
j=imnoise(i,'salt & pepper',0.02);
s= strel('disk',1);
k=imopen(j,s);
n=imclose(k,s);
f=imclose(j,s);
p=imopen(n,s);
figure(1);subplot(1,5,1);imshow(j);
subplot(1,5,2);imshow(k);
subplot(1,5,3);imshow(f);
subplot(1,5,4);imshow(n);
subplot(1,5,5);imshow(p);
axes(handles.axesres);
handles.tochanged=p;
guidata(hObject,handles);
imshow(p);


% --------------------------------------------------------------------
function Frequence_Callback(hObject, eventdata, handles)
% hObject    handle to Frequence (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function FFT_Callback(hObject, eventdata, handles)
% hObject    handle to FFT (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end

I=img
F=fft2(double(I));
S=fftshift(F);
F = abs(F); % Get the magnitude
F = log(F+1); % Use log, for perceptual scaling, and +1 since log(0) is undefined
F = mat2gray(F); % Use mat2gray to scale the image between 0 and 1


axes(handles.axesres);
handles.tochanged=F;
guidata(hObject,handles);
imshow(F,[]); % Display the result



% --------------------------------------------------------------------
function DCT_Callback(hObject, eventdata, handles)
% hObject    handle to DCT (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end

RGB = img;
I = RGB;
J = dct2(I);
figure, imshow(log(abs(J)),[]), colormap(gca,jet(64)), colorbar
J(abs(J) < 10) = 0;
K = idct2(J);
imshow(I)
figure, imshow(K,[0 255])
title('Image DCT');
axes(handles.axesres);
handles.tochanged=K;
guidata(hObject,handles);
imshow(K,[0 255])

% --------------------------------------------------------------------
function FFT1D_Callback(hObject, eventdata, handles)
% hObject    handle to FFT1D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end
img=double(img);
[Nlin, Ncol] = size(img) ;
figure(1); image(img);
Freq_MonSignal = fft(img);

axes(handles.axesres);
handles.tochanged=Freq_MonSignal;
guidata(hObject,handles);
imshow(Freq_MonSignal)
% --------------------------------------------------------------------
function Colormap_Callback(hObject, eventdata, handles)
% hObject    handle to Colormap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end


I = img;
% LUT pour afficher limagetexture clown_lumi en niveaux de gris
r=0:1/255:1;
v=0:1/255:1;
b=0:1/255:1;
map=[r' v' b'];
image (I);
colormap(map)
% LUT si on souhaite compenser le gamma de l'cran
vect = 0:1/255:1;
gamma_r = 2.2; % Niveau_sortie=Niveau_entre^2.2 pour le rouge
gamma_v = 2.3; % Niveau_sortie=Niveau_entre^2.3 pour le vert
gamma_b = 2.1; % Niveau_sortie=Niveau_entre^2.1 pour le bleu
r = vect.^(1/gamma_r);
v = vect.^(1/gamma_v);
b = vect.^(1/gamma_b); 
% on fabrique la LUT  l'aide des 3 vecteurs
map_gamma_inv = [r' v' b'];
% pour appliquer la LUT
% figure
% image(I)
colormap(map_gamma_inv);
axes(handles.axesres);
handles.tochanged=I;
guidata(hObject,handles);
imshow(I);


% --------------------------------------------------------------------
function Histogram_Callback(hObject, eventdata, handles)
% hObject    handle to Histogram (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function ImageNvg_Callback(hObject, eventdata, handles)
% hObject    handle to ImageNvg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.axesorig);
img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end
axes(handles.axesres);
handles.tochanged=img;
guidata(hObject,handles);
%figure('Toolbar','none','Name','Selected calchistogramme','NumberTitle','off'),
imshow(img);


% --------------------------------------------------------------------
function Moyenne_Callback(hObject, eventdata, handles)
% hObject    handle to Moyenne (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.axesorig);
img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end
moyenne=mean(img(:))


% --------------------------------------------------------------------
function Mediane_Callback(hObject, eventdata, handles)
% hObject    handle to Mediane (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.axesorig);
img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end
mediane=median(img(:))


% --------------------------------------------------------------------
function Variance_Callback(hObject, eventdata, handles)
% hObject    handle to Variance (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.axesorig);
img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end
I = double(img);
%Define the window size
sz = 5;
mn=floor(sz/2);
%Preallocate the matrix
Output = zeros(size(I));
%Pad the matrix with zeros
I = padarray(I,[mn mn]);

for i=1:size(I,1)-mn*2
for j=1:size(I,2)-mn*2
tmp = I(i:i+(sz-1),j:j+(sz-1));
mu = mean(tmp(:));
        tmp2 = mean(tmp(:).^2);
Output(i,j)=tmp2 - mu.^2;
end
end

figure,imagesc(Output);colormap(gray);


% --------------------------------------------------------------------
function Moments_Callback(hObject, eventdata, handles)
% hObject    handle to Moments (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.axesorig);
img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end
I = double(img);
[r c]=size(I); 
m=zeros(r,c); 
% geometric moments 
for i=0:1 
    for j=0:1 
        for x=1:r 
            for y=1:c 
                m(i+1,j+1)=m(i+1,j+1)+(x^i*y^j*I(x,y)); 
            end
        end
    end
end
xb=m(2,1)/m(1,1); 
yb=m(1,2)/m(1,1);
% central moments 
u=[ 0 0 0 0;0 0 0 0;0 0 0 0;0 0 0 0]; 
for i=0:3 
    for j=0:3 
        for x=1:r 
            for y=1:c 
                u(i+1,j+1)=u(i+1,j+1)+(x-xb)^i*(y-yb)^j*I(x,y); 
            end
        end
    end
end
% scale invariant moments 
n=[ 0 0 0 0;0 0 0 0;0 0 0 0;0 0 0 0]; 
for i=0:3 
    for j=0:3 
        n(i+1,j+1)=u(i+1,j+1)/(u(1,1)^(1+(i+j)/2)); 
    end
end
%rotation invariant moments 
I_1= n(3,1)+ n(1,3); 
I_2=(n(3,1)- n(1,3) )^2+ (2*n(2,2))^2; 
I_3=(n(4,1)-3*n(2,3))^2+ (3*n(3,2)-n(1,4))^2; 
I_4=(n(4,1)+n(2,3))^2+ (n(3,2)+n(1,4))^2; 
I_5=(n(4,1)-3*n(2,3))*(n(4,1)+n(2,3))*((n(4,1)+n(2,3))^2-3*(n(3,2)+n(1,4))^2)...
    +(3*n(3,2)-n(1,4))*(n(3,2)+n(1,4))*(3*(n(4,1)+n(2,3))^2-(n(3,2)+n(1,4))^2); 
I_6=(n(3,1)-n(1,3))*((n(4,1)+n(2,3))^2-(n(3,2)+n(1,4))^2)+ 4*n(2,2)*(n(4,1)...
    +n(2,3))*(n(3,2)+n(1,4)); 
I_7=(3*n(3,2)-n(1,4))*(n(4,1)+n(2,3))*((n(4,1)+n(2,3))^2- 3*(n(3,2)+n(1,4))^2 )...
    - (n(1,4)-3*n(2,3))*(n(3,2)+n(1,4))*(3*(n(4,1)+n(2,3))^2-(n(3,2)+n(1,4))^2);
M= [I_1 I_2 I_3 I_4 I_5 I_6 I_7]





% --------------------------------------------------------------------
function PoivreetSel_Callback(hObject, eventdata, handles)
% hObject    handle to PoivreetSel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.axesorig);
img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end
J = imnoise(img,'salt & pepper',0.02);
K = medfilt2(J);
% imshow(J)
axes(handles.axesres);
handles.tochanged=K;
guidata(hObject,handles);
imshow(K);


% --------------------------------------------------------------------
function Resize_Callback(hObject, eventdata, handles)
% hObject    handle to Resize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.axesorig);
img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end

prompt = {'Entrer la nouvelle hauteur'};
dlg_title = 'Height value';
new_height = 1; 
answer = inputdlg(prompt,dlg_title,new_height);
aN=str2double(answer(1));
NH=aN;

prompt = {'Entrer la nouvelle largeur'};
dlg_title = 'Width value';
new_width = 1; 
answer = inputdlg(prompt,dlg_title,new_width);
aN=str2double(answer(1));
NL=aN;

K = imresize(img, [NL NH]);
figure, imshow(K)


 
 


% --------------------------------------------------------------------
function AffichCanauxRGB_Callback(hObject, eventdata, handles)
% hObject    handle to AffichCanauxRGB (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.axesorig);
img=handles.tochanged;
[rows columns numberOfColorChannels] = size(img);
if numberOfColorChannels > 1
    % Color
    img = rgb2gray(img);
else
    % nvg or binary
    maxValue = max(img(:));
    if maxValue==1 
        img=im2uint8(img);
    end
end
 
RGB=img;
R = RGB;
R(:,:,2) = 0;
R(:,:,3) = 0;
 
G = RGB;
G(:,:,1) = 0;
G(:,:,3) = 0;
 
B = RGB;
B(:,:,1) = 0;
B(:,:,2) = 0;
 
figure
subplot(2,2,1);
image(RGB);
axis image
title('Image RGB')
 
subplot(2,2,2);
image(R);
axis image
title('Composante R')
 
subplot(2,2,3);
image(G);
axis image
title('Composante G')
 
subplot(2,2,4);
image(B);
axis image
title('Composante B')


% --------------------------------------------------------------------
function ReadFile_Callback(hObject, eventdata, handles)
% hObject    handle to ReadFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
